

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Summer School StrongMAR - 2016
% Time and Frequency Modelling
% Paulo Santos 
% 29th June, 2016
%
% Impulse response synthesis using Kraken
% and Fourier synthesis
% pjsantos@ualg.pt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

addpath('ReadWrite\')

%%%% general
fs=10000 %sampling frequency 
Tw=0.100 %lenght of impulse response
N=fix(fs*Tw) %FFT length
nb=ceil(log2(N)); % next pow-2 
N=2^nb; %not a must
df=fs/N; % frequency step

%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Source depth 6m
%
%frequency band considered
%fmin=400
%fmax=800

%fmin=1500
%fmax=3500

fmin=6500 %lower limit
fmax=8500 %upper limit
kmin=fix(fmin/df); %frequency index (lower)
kmax=fix(fmax/df); %frequency index (upper)
kk=kmin:kmax;
f=(kmin:kmax)*df; %frequencies

nfreqs=kmax-kmin+1;

%%%%
%
% n. of receivers=4
% receivers depth 3.7m; 3.8m; 3.9m; 4.0m
% range 90m
%
%%%%
Nrecv=4
H=zeros(Nrecv,N)

%fname='isopapBB'
fname='isopapTestsBB'
for jj=1:nfreqs
    f(jj)
    xgBellEnvFreq([fname '.env'],'mod.env', f(jj));
   !kraken mod
   eval(['!field  mod <' fname '.flp'])

  %Pos struct info about src and recv
  %P   field (pressure)

%using matlab
%load([fname 'P.mat']) ;
   [ PlotTitle, PlotType, freq, atten, Pos, p ] = read_shd( ['mod.shd'] );

   P=squeeze(p); % P is the pressure field 4D array 
              % in this case only 2D (ND X NR)
   P=double(P); % field uses single precision, pcolor needs double
   H(:,kk(jj)+1)=P; %H frequency response
   H(:,N-kk(jj)+1)=conj(P); % Using FT proprieties of real signals 
end
hh=ifft(H.');  % impulse response is the inverse  TF of H
ehh=abs(hilbert(hh)); %arrival pattern (envelope of the impulse resposne)

mxv=max(max(ehh)); % find max value to scale plot
tt=(0:N-1)/fs*1000; %time (ms) 


cor=['b';'g';'m';'r']; %color table 
figure
hold    
for j=1:Nrecv
    plot(tt,(Nrecv-(j-1))*1.25*mxv+hh(:,j),cor(j)) % plot impulse responses
end
xlabel('time (ms)')
legend('hyd 3.7m','hyd 3.8m','hyd 3.9m','hyd 4.0m')
set(gca,'Xlim',[0 tt(end)],'YTickLabel',[]) %set the range of time axes, remove labels from y axes

pause
figure
hold
for j=1:Nrecv
    plot(tt,(Nrecv-(j-1))*mxv+ehh(:,j),cor(j)) % plot impulse responses
end
xlabel('time (s)')
legend('hyd 3.7m','hyd 3.8m','hyd 3.9m','hyd 4.0m')
set(gca,'Xlim',[0 tt(end)])
set(gca,'Xlim',[0 tt(end)],'YTickLabel',[]) %set the range of time axes, remove labels from y axes

pause
figure
hold
plot(tt,ehh(:,1),'b')
plot(tt,ehh(:,end),'r')
xlabel('time (s)')
%legend('shallowest hyd', 'deepest hyd')
legend('hyd 3.7m','hyd 4.0m')
set(gca,'Xlim',[0 tt(end)])
